From 1661b7a7c066c84363830028b4b00006da9f8e69 Mon Sep 17 00:00:00 2001
From: Marko Lindqvist <cazfi74@gmail.com>
Date: Thu, 18 Jan 2024 21:40:23 +0200
Subject: [PATCH 44/44] Update .m4 -files from gettext-0.23

gettext.m4: Serial 79
intlmacosx.m4: Serial 10

See RM #185

Signed-off-by: Marko Lindqvist <cazfi74@gmail.com>
---
 m4/gettext.m4    | 24 ++++++++++++------------
 m4/intlmacosx.m4 | 12 ++++++------
 2 files changed, 18 insertions(+), 18 deletions(-)

diff --git a/m4/gettext.m4 b/m4/gettext.m4
index 16f9db1879..5d47445d69 100644
--- a/m4/gettext.m4
+++ b/m4/gettext.m4
@@ -1,5 +1,5 @@
-# gettext.m4 serial 78 (gettext-0.22.4)
-dnl Copyright (C) 1995-2014, 2016, 2018-2023 Free Software Foundation, Inc.
+# gettext.m4 serial 79 (gettext-0.23)
+dnl Copyright (C) 1995-2014, 2016, 2018-2024 Free Software Foundation, Inc.
 dnl This file is free software; the Free Software Foundation
 dnl gives unlimited permission to copy and/or distribute it,
 dnl with or without modifications, as long as this notice is preserved.
@@ -182,9 +182,9 @@ return * gettext ("")$gt_expression_test_code + __GNU_GETTEXT_SYMBOL_EXPRESSION
           AC_LIB_LINKFLAGS_BODY([intl])
           AC_CACHE_CHECK([for GNU gettext in libintl],
             [$gt_func_gnugettext_libintl],
-           [gt_save_CPPFLAGS="$CPPFLAGS"
+           [gt_saved_CPPFLAGS="$CPPFLAGS"
             CPPFLAGS="$CPPFLAGS $INCINTL"
-            gt_save_LIBS="$LIBS"
+            gt_saved_LIBS="$LIBS"
             LIBS="$LIBS $LIBINTL"
             dnl Now see whether libintl exists and does not depend on libiconv.
             AC_LINK_IFELSE(
@@ -246,8 +246,8 @@ return * gettext ("")$gt_expression_test_code + __GNU_GETTEXT_SYMBOL_EXPRESSION
                  eval "$gt_func_gnugettext_libintl=yes"
                 ])
             fi
-            CPPFLAGS="$gt_save_CPPFLAGS"
-            LIBS="$gt_save_LIBS"])
+            CPPFLAGS="$gt_saved_CPPFLAGS"
+            LIBS="$gt_saved_LIBS"])
         fi
 
         dnl If an already present or preinstalled GNU gettext() is found,
@@ -365,9 +365,9 @@ return * gettext ("")$gt_expression_test_code + __GNU_GETTEXT_SYMBOL_EXPRESSION
 
   dnl Define localedir_c and localedir_c_make.
   dnl Find the final value of localedir.
-  gt_save_prefix="${prefix}"
-  gt_save_datarootdir="${datarootdir}"
-  gt_save_localedir="${localedir}"
+  gt_saved_prefix="${prefix}"
+  gt_saved_datarootdir="${datarootdir}"
+  gt_saved_localedir="${localedir}"
   dnl Unfortunately, prefix gets only finally determined at the end of
   dnl configure.
   if test "X$prefix" = "XNONE"; then
@@ -376,9 +376,9 @@ return * gettext ("")$gt_expression_test_code + __GNU_GETTEXT_SYMBOL_EXPRESSION
   eval datarootdir="$datarootdir"
   eval localedir="$localedir"
   gl_BUILD_TO_HOST([localedir])
-  localedir="${gt_save_localedir}"
-  datarootdir="${gt_save_datarootdir}"
-  prefix="${gt_save_prefix}"
+  localedir="${gt_saved_localedir}"
+  datarootdir="${gt_saved_datarootdir}"
+  prefix="${gt_saved_prefix}"
 ])
 
 
diff --git a/m4/intlmacosx.m4 b/m4/intlmacosx.m4
index 3141bf8c5e..450eb8898a 100644
--- a/m4/intlmacosx.m4
+++ b/m4/intlmacosx.m4
@@ -1,5 +1,5 @@
-# intlmacosx.m4 serial 9 (gettext-0.22.3)
-dnl Copyright (C) 2004-2014, 2016, 2019-2023 Free Software Foundation, Inc.
+# intlmacosx.m4 serial 10 (gettext-0.23)
+dnl Copyright (C) 2004-2014, 2016, 2019-2024 Free Software Foundation, Inc.
 dnl This file is free software; the Free Software Foundation
 dnl gives unlimited permission to copy and/or distribute it,
 dnl with or without modifications, as long as this notice is preserved.
@@ -20,7 +20,7 @@ AC_DEFUN([gt_INTL_MACOSX],
   dnl Check for API introduced in Mac OS X 10.4.
   AC_CACHE_CHECK([for CFPreferencesCopyAppValue],
     [gt_cv_func_CFPreferencesCopyAppValue],
-    [gt_save_LIBS="$LIBS"
+    [gt_saved_LIBS="$LIBS"
      LIBS="$LIBS -Wl,-framework -Wl,CoreFoundation"
      AC_LINK_IFELSE(
        [AC_LANG_PROGRAM(
@@ -28,7 +28,7 @@ AC_DEFUN([gt_INTL_MACOSX],
           [[CFPreferencesCopyAppValue(NULL, NULL)]])],
        [gt_cv_func_CFPreferencesCopyAppValue=yes],
        [gt_cv_func_CFPreferencesCopyAppValue=no])
-     LIBS="$gt_save_LIBS"])
+     LIBS="$gt_saved_LIBS"])
   if test $gt_cv_func_CFPreferencesCopyAppValue = yes; then
     AC_DEFINE([HAVE_CFPREFERENCESCOPYAPPVALUE], [1],
       [Define to 1 if you have the Mac OS X function CFPreferencesCopyAppValue in the CoreFoundation framework.])
@@ -43,7 +43,7 @@ AC_DEFUN([gt_INTL_MACOSX],
   dnl CFPreferencesCopyAppValue still returns, namely ll_CC where ll is the
   dnl first among the preferred languages and CC is the territory.
   AC_CACHE_CHECK([for CFLocaleCopyPreferredLanguages], [gt_cv_func_CFLocaleCopyPreferredLanguages],
-    [gt_save_LIBS="$LIBS"
+    [gt_saved_LIBS="$LIBS"
      LIBS="$LIBS -Wl,-framework -Wl,CoreFoundation"
      AC_LINK_IFELSE(
        [AC_LANG_PROGRAM(
@@ -51,7 +51,7 @@ AC_DEFUN([gt_INTL_MACOSX],
           [[CFLocaleCopyPreferredLanguages();]])],
        [gt_cv_func_CFLocaleCopyPreferredLanguages=yes],
        [gt_cv_func_CFLocaleCopyPreferredLanguages=no])
-     LIBS="$gt_save_LIBS"])
+     LIBS="$gt_saved_LIBS"])
   if test $gt_cv_func_CFLocaleCopyPreferredLanguages = yes; then
     AC_DEFINE([HAVE_CFLOCALECOPYPREFERREDLANGUAGES], [1],
       [Define to 1 if you have the Mac OS X function CFLocaleCopyPreferredLanguages in the CoreFoundation framework.])
-- 
2.43.0